---
title: 'SyntaxError: illegal character'
slug: Web/JavaScript/Reference/Errors/Illegal_character
tags:
  - Error
  - Errors
  - JavaScript
  - SyntaxError
---
<p>{{jsSidebar("Errors")}}</p>

<p>The JavaScript exception "illegal character" occurs when there is an invalid or unexpected token that doesn't belong at this position in the code.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">SyntaxError: Invalid character (Edge)
SyntaxError: illegal character (Firefox)
SyntaxError: Invalid or unexpected token (Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>There is an invalid or unexpected token that doesn't belong at this position in the code. Use an editor that supports syntax highlighting and carefully check your code against mismatches like a minus sign (<code> - </code>) versus a dash (<code> – </code>) or simple quotes (<code> " </code>) vs non-standard quotation marks (<code> “ </code>).</p>

<h2 id="Examples">Examples</h2>

<h3 id="Mismatched_characters">Mismatched characters</h3>

<p>Some characters look similar, but will cause the parser to fail interpreting your code. Famous examples of this are quotes, the minus or semicolon (<a href="https://en.wikipedia.org/wiki/Question_mark#Greek_question_mark">greek questionmark (U+37e)</a> looks same).</p>

<pre class="brush: js example-bad">“This looks like a string”;  // SyntaxError: illegal character
                             // “ and ” are not " but look like this

42 – 13;                     // SyntaxError: illegal character
                             // – is not - but looks like this

var foo = 'bar';             // SyntaxError: illegal character
                             // &lt;37e&gt; is not ; but looks like this
</pre>

<p>This should work:</p>

<pre class="brush: js example-good">"This is actually a string";
42 - 13;
var foo = 'bar';
</pre>

<p><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="objectBox objectBox-string">Some editors and IDEs will notify you or at least use a slightly different highlighting for it, but not all. When something like this happens to your code and you're not able to find the source of the problem, it's often best to just delete the problematic line and retype it.</span></span></span></span></p>

<h3 id="Forgotten_characters">Forgotten characters</h3>

<p>It's easy to forget a character here or there.</p>

<pre class="brush: js example-bad">var colors = ['#000', #333', '#666'];
// SyntaxError: illegal character
</pre>

<p>Add the missing quote for <code><strong>'</strong>#333'</code>.</p>

<pre class="brush: js example-good">var colors = ['#000', '#333', '#666'];</pre>

<h3 id="Hidden_characters">Hidden characters</h3>

<p>When copy pasting code from external sources, there might be invalid characters. Watch out!</p>

<pre class="brush: js example-bad">var foo = 'bar';
// SyntaxError: illegal character
</pre>

<p>When inspecting this code in an editor like Vim, you can see that there is actually a <a href="https://en.wikipedia.org/wiki/Zero-width_space">zero-width space (ZWSP) (U+200B)</a> character.</p>

<pre class="brush: js">var foo = 'bar';&lt;200b&gt;</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar">Lexical grammar</a></li>
</ul>
